import sys
import os
import subprocess

"""""
Single file / folder / (later list.txt / regex): -> also generates link file!
10f [-i][-f][-r][-n] name foldername filename

-i = insert/update data (as opposed to download)
-f = folder
-u = update
-n = no error if linkfile already exists

# Get data, ONLY use the link file
10f name.10f

"""

def print_specific_help(specific_help_type):
    if specific_help_type == '-i':
        print('Insert: use to insert new data:')
        print('example:')
        print('10f -i dataname foldername filename')
        print('10f -i -f dataname foldername [regex]')
    if specific_help_type == '-d':
        print('Download data from a link.')
        print('example:')
        print('10f -d mylink.10f')
        print('10f -d mylink.10f tmp/storage/personal')
    if specific_help_type == '-f':
        print('Folder: Inserts the folder as data.')
    if specific_help_type == '-u':
        print('Update / Refresh (use this if the data already exists).')
        print('example:')
        print('10f -u dataname foldername filename')
        print('10f -u -f dataname foldername  [regex]')
    if specific_help_type == '-n':
        print('Overwrites without error if the resulting linkfile exists.')
    if specific_help_type == '-c':
        print('Create a link')
        print('example:')
        print('10f -c dataname')
    if specific_help_type == '-l':
        print('List information')
        print('example for the global database:')
        print('example for the global database:')
        print('10f -l')
        print('example for a specific entry:')
        print('10f -l dataname')

    sys.exit(0)

def print_help():
    print('Tenfingers usage:')
    print('')
    print('10f [-i][-f][-u][-n][-l] name [foldername] [filename][regex]')
    print('10f -d linkfile [destfolder]')
    print('')
    print('-i = insert/update data (as opposed to download)')
    print('-f = folder')
    print('-u = update/refresh')
    print('-n = no error if linkfile already exists')
    print('-c = create a link')
    print('-l [name] = list information')
    print('-h [-i,-d,-f,-r,-n,-c] specific help')
    print('')
    print('Get data from link')
    print('10f name.10f')
    sys.exit(0)


if len(sys.argv) == 1:
    print_help()


cmd = {}
commands = {'-h', '-d', '-i', '-f', '-u', '-n', '-c', '-l'}
specific_help = False
specific_help_type = False

for c in sys.argv:
    if c[:1] == '-':
        if specific_help and not specific_help_type:
            specific_help_type = c

        if c == '-h':  # Specific help:
            specific_help = True
        if c in commands:
            cmd[c] = True
        else:
            print('Unknown command:', c)
            print_help()


if specific_help:
    if specific_help_type == False:
        print_help()
    else:
        print_specific_help(specific_help_type)
        sys.exit(-1)

noerror = '-n' in cmd

if '-i' in cmd:
    from insert_data import main as insert_data_main
    if '-f' in cmd: # variable length number of argv, regex is optional
        print('Insert folder:')
        if len(sys.argv) == 4:
            insert_data_main(['', sys.argv[2], sys.argv[3]])  # To test
        if len(sys.argv) == 5:
            insert_data_main(['', sys.argv[2], sys.argv[3], sys.argv[4]])  # To test
    else:
        print('Insert file:')
        insert_data_main(['', sys.argv[2], sys.argv[3], sys.argv[4]])  # WORKS

    # make the link NO because it's stupid
    #if len(sys.argv) >= 3:
    #    from get_link_from_data import create_and_save_link
    #    create_and_save_link(sys.argv[2])

    sys.exit(0)

if '-c' in cmd:
    if len(sys.argv) == 3:
        print('Create link for', sys.argv[2])
        from get_link_from_data import create_and_save_link
        create_and_save_link(sys.argv[2])
    else:
        print_specific_help('-c')

    sys.exit(0)

if '-d' in cmd:
    if len(sys.argv) == 3 or len(sys.argv) == 4:
        destfolder = './'
        if len(sys.argv) == 4:
            destfolder = sys.argv[3]
        # def get_data(linkfile, dest_folder):
        from get_data_from_link import get_data
        get_data(sys.argv[2], destfolder)
        sys.exit(0)

if '-l' in cmd:
    # List stuff
    import database_query as dq

    if len(sys.argv) == 3:
        print('Show information for the data ['+sys.argv[2]+']')
        # Show the fingers for this entry:
        dq.flush_fingers(sys.argv[2])
    else:
        print('Show general information:')
        # Flush generic data about nodes, data etc.
        dq.flush_owned_data()
        dq.flush_shared_data()

    sys.exit(0)



if '-u' in cmd:
    from update_data import main as update_data_main
    if '-f' in cmd:
        print('Update folder:')
        if len(sys.argv) == 4:
            update_data_main(['', sys.argv[2], sys.argv[3]])  # To test
        if len(sys.argv) == 5:
            update_data_main(['', sys.argv[2], sys.argv[3], sys.argv[4]])  # To test
    else:
        print('Update file:')
        update_data_main(['', sys.argv[2], sys.argv[3], sys.argv[4]])  # To test

    sys.exit(0)

#from get_link_from_data import create_and_save_link
#create_and_save_link(linkfile)  # to test


if len(cmd) == 0:
    if len(sys.argv) >= 2:
        linkfile = sys.argv[1]
        print('Load:', linkfile)
        from get_data_from_link import get_data

        destfolder = './'
        if len(sys.argv) == 3:
            destfolder = sys.argv

        get_data(linkfile, destfolder)

        sys.exit(0)





print_help()

































